<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 37.30</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
<!-- Data Table-->
<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body class="container">
    <div class="text-center mt-3">
      <h2>Danh sách người dùng đăng ký</h2>
    </div>
    <div class="form-group">
      <button id="btn-add-user" class="btn btn-success ">New user</button>
    </div>
    <div class="container">
    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <th>Id</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
    </table>
</div>
</body>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
   var gUserId=0;
    //set properties of the table's data
    const gUSER_COLs = ['id', 'firstname', 'lastname', 'country', 'subject', 'customerType', 'registerStatus', 'action'];

    //set columns for the table
    const gUSER_ID_COL = 0;
    const gUSER_FIRST_NAME_COL = 1;
    const gUSER_LAST_NAME_COL = 2;
    const gUSER_COUNTRY_COL = 3;
    const gUSER_SUBJECT_COL = 4;
    const gUSER_CUSTOMER_TYPE_COL = 5;
    const gUSER_REGISTER_STATUS_COL = 6;
    const gUSER_ACTION_COL = 7;

    var gUserTable = $("#user-table").DataTable({
        columns: [
            {data: gUSER_COLs[gUSER_ID_COL]},
            {data: gUSER_COLs[gUSER_FIRST_NAME_COL]},
            {data: gUSER_COLs[gUSER_LAST_NAME_COL]},
            {data: gUSER_COLs[gUSER_COUNTRY_COL]},
            {data: gUSER_COLs[gUSER_SUBJECT_COL]},
            {data: gUSER_COLs[gUSER_CUSTOMER_TYPE_COL]},
            {data: gUSER_COLs[gUSER_REGISTER_STATUS_COL]},
            {data: gUSER_COLs[gUSER_ACTION_COL]},
        ],
        columnDefs: [
          {
            targets: gUSER_ACTION_COL,
            defaultContent: `
              <img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
              <img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
            `
          }
        ]
     });
        

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    

    $(document).ready(function(){
      onPageLoading();
    });

      $("#user-table").on('click', ".edit-user", function(){
        onBtnEditUserClick(this);
      });
      $("#user-table").on('click', ".delete-user", function(){
        onBtnDeleteUserClick(this);
      });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading(){
      getAllUsers();
    };
    function onBtnEditUserClick(paramBtnEdit){
      gUserId = getUserIdFrombutton(paramBtnEdit);
      console.log(gUserId)
    }
    function onBtnDeleteUserClick(paramBtnDelete){
    gUserId = getUserIdFrombutton(paramBtnDelete);
    console.log("Id của user tương ứng = " + gUserId);
    }
     
    
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //load data to the table
    function loadDataToUserTable(paramUser){
      gUserTable.clear();
      gUserTable.rows.add(paramUser);
      gUserTable.draw();
     
    };
 //call API for load users' data
 function getAllUsers(){
      $.ajax({
        url: gBASE_URL,
        type: "GET",
        success: function(paramUsers){
          console.log(paramUsers);
          loadDataToUserTable(paramUsers);
        },
        error: function(paramErr){
          console.log(paramErr.status)
        }
      });
    }
    function getUserIdFrombutton(paramButton){
      var vTableRow = $(paramButton).parents("tr");
      var vUserDataRow = gUserTable.row(vTableRow).data();
      return vUserDataRow.id;;
    }
    
</script>
</html>

